/*
 * example_map.cpp
 *
 *  Created on: May 1, 2011
 *      Author: lipari
 */

#include "example_map.hpp"

using namespace std;
namespace oosd
{
	ExampleMap& ExampleMap::instance()
	{
		static ExampleMap _instance;
		return _instance;
	}

	void ExampleMap::registerFun(const string &s, EXAMPLE_FUN pf)
	{
		fmap[s] = pf;
	}

	void ExampleMap::execute(const string &s)
	{
		cout << "********* " << s << " ***********" << endl;
		FMAP_ITER i = fmap.find(s);
		if (i != fmap.end()) (*(i->second))();
		else cout << " #### NOT FOUND #### " << endl;
	}

	void ExampleMap::execute_all()
	{
		for (FMAP_ITER i = fmap.begin(); i != fmap.end(); ++i) {
			cout << "********* " << i->first << " ***********" << endl;
			(*(i->second))();
		}
	}
}
