/*
 * example_map.hpp
 *
 *  Created on: May 1, 2011
 *      Author: lipari
 */

#ifndef EXAMPLE_MAP_HPP_
#define EXAMPLE_MAP_HPP_

#include <iostream>
#include <map>
#include <string>

namespace oosd {
	class ExampleMap {
	public:
		typedef int (*EXAMPLE_FUN)();
	private:
		typedef std::map<std::string, EXAMPLE_FUN> FMAP;
		typedef std::map<std::string, EXAMPLE_FUN>::iterator FMAP_ITER;

		FMAP fmap;

		ExampleMap() {}
		ExampleMap(const ExampleMap &);
		ExampleMap &operator=(const ExampleMap &);
	public:
		static ExampleMap& instance();
		void registerFun(const std::string &s, EXAMPLE_FUN pf);
		void execute(const std::string &s);
		void execute_all();
	};

	struct register_in_map {
		register_in_map(const std::string &s, ExampleMap::EXAMPLE_FUN pf) {
			ExampleMap::instance().registerFun(s, pf);
		}
	};
}

#define EXAMPLE ExampleMap::instance()

#endif /* EXAMPLE_MAP_HPP_ */
