/*
 * thread_ex.cpp
 *
 *  Created on: Mar 24, 2011
 *      Author: lipari
 */

#include <iostream>
#include <string>
#include <boost/thread.hpp>
#include "thread_ex.hpp"
#include "example_map.hpp"

using namespace std;

namespace thread_example
{
	oosd::register_in_map __reg("thread_example1", run);

	void mybody()
	{
		cout << "This is a thread" << endl;
	}

	void body2(int index)
	{
		cout << "This is thread with index = " << index << endl;
	}

	struct MyCallable {
		int i;
		MyCallable(int index) :
			i(index) {
		}
		void operator()() {
			cout << "This is a thread with callable, index = " << i << endl;
		}
	};

	int body3(const string &name, int index)
	{
		cout << "Thread " << name << " with index " << index << endl;
		return index + 1;
	}

	int run()
	{
		MyCallable c(4);

		boost::thread t1(mybody);

		boost::thread t2(body2, 0);
		boost::thread t3(body2, 1);

		boost::thread t4(c);

		boost::thread t5(body3, "MyThread", 5);

		t1.join();
		t2.join();
		t3.join();
		t4.join();
		t5.join();

		cout << "Finished" << endl; // prints
		return 0;
	}
}
